//---------------------------------------------------------------------------

#ifndef FormButtonContainerH
#define FormButtonContainerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
#include <vector>

#include "ButtonType.h"

class TProgrammableButton;

class TfrmButtonContainer : public TForm
{
__published:	// IDE-managed Components
	TFlowPanel *flowPanel;
	TImageList *imgList;
	TPopupMenu *popupPanel;
	TMenuItem *miEditSpeedDial;
	void __fastcall miEditSpeedDialClick(TObject *Sender);
public:
	typedef void (__closure *CallbackClick)(int id, TProgrammableButton* btn);
	void UpdateDlgInfoState(int id, int state);
	void UpdateBtnState(Button::Type type, bool state);
	void UpdateMwiState(int newMsg, int oldMsg);
private:	// User declarations
	CallbackClick callbackClick;
	void __fastcall SpeedDialPanelClick(TObject *Sender);
	void EditContact(int id);
	std::vector<TProgrammableButton*> vpanels;
	int startBtnId;
	int btnCnt;
public:		// User declarations
	__fastcall TfrmButtonContainer(TComponent* Owner, int width, int height,
		int startBtnId, int btnCnt, CallbackClick callbackClick);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmButtonContainer *frmButtonContainer;
//---------------------------------------------------------------------------
#endif
